;==============================================================================
;
; Author:      blueb     
; Date:       June 2, 2017
; Explain:     Needed a small program to keep various colors
;           
; Typical Usage: EasyPalette.EXE list keeper
;
; Credits:
; This program is based on a forum sample I've had forever... EditPlayList.pb
; but can't locate the forum source or the author, but thank you for the sample.
;
;===============================================================================

Global sFile.s
sFile = "EasyPalette.ini"

Enumeration 
     ; Windows 
     #frmMain 
     #frmAddEdit 
     ; Main Form Gadgets 
     #frmMain_ligStations 
     #frmMain_cmdAdd 
     #frmMain_cmdEdit 
     #frmMain_cmdDelete
     #frmMain_cmdCopyINI
     #frmMain_cmdExit
     ; Edit Form Gadgets     
     #frmAddEdit_lblName 
     #frmAddEdit_txtName 
     #frmAddEdit_lblUrl 
     #frmAddEdit_txtUrl 
     #frmAddEdit_cmdOK 
     #frmAddEdit_cmdCancel
     #frmAddEdit_cmdInject
     #frmAddEdit_cmdFlip
     #frmAddEdit_cmdCopy
     ; Misc 
     #AddStation 
     #EditStation 
EndEnumeration 

Structure s_Station 
     Name.s 
     Url.s 
EndStructure 

Global NewList Stations.s_Station() 
Global Mode.i 
; --------------------------------------

Procedure.i Open_frmMain() 
   Protected  hFont.i
     If OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 600, 300, "EasyPalette List", #PB_Window_ScreenCentered | #PB_Window_SystemMenu) 
          
          ListIconGadget(#frmMain_ligStations, 5, 5, 500, 280, "Name of Palette", 248, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_AlwaysShowSelection)
          
          AddGadgetColumn(#frmMain_ligStations, 1, "HTML Hex Color String", 248) 
          ; Font
          hFont.i = LoadFont(1, "Arial Rounded MT Bold", 10)
          SetGadgetFont(#frmMain_ligStations, hFont)
          ;
          ; Color the Listview
          SetGadgetColor(#frmMain_ligStations,  #PB_Gadget_FrontColor,RGB(25, 25, 112))
          SetGadgetColor(#frmMain_ligStations, #PB_Gadget_BackColor, RGB(255, 255, 212))
          ;                 
          ButtonGadget(#frmMain_cmdAdd, 520, 5, 65, 25, "Add") 
          ButtonGadget(#frmMain_cmdEdit, 520, 35, 65, 25, "Edit") 
          ButtonGadget(#frmMain_cmdDelete, 520, 65, 65, 25, "Delete") 
          ButtonGadget(#frmMain_cmdCopyINI, 520, 230, 65, 25, "Backup File")
          ButtonGadget(#frmMain_cmdExit, 520, 260, 65, 25, "Exit")
          
          SetWindowColor(#frmMain, $A2BADA)
          StickyWindow(#frmMain, #True)
          
          ProcedureReturn  #True 
          
     EndIf 
EndProcedure 

Procedure.i Open_frmAddEdit() 
     
     If OpenWindow(#frmAddEdit, #PB_Ignore, #PB_Ignore, 480, 108, "EasyPalette List", #PB_Window_ScreenCentered | #PB_Window_SystemMenu, WindowID(#frmMain)) 
          
          DisableWindow(#frmMain, #True) ;disable main window while doing work
          
          TextGadget(#frmAddEdit_lblName, 10, 10, 45, 20, "Name:") 
          SetGadgetColor(#frmAddEdit_lblName, #PB_Gadget_BackColor, $A2BADA)
          
          StringGadget(#frmAddEdit_txtName, 60, 10, 410, 20, "") 
          
          TextGadget(#frmAddEdit_lblUrl, 10, 35, 45, 20, "HexString:")
          SetGadgetColor(#frmAddEdit_lblUrl, #PB_Gadget_BackColor, $A2BADA)
          StringGadget(#frmAddEdit_txtUrl, 60, 35, 410, 20, "") 
          
          ButtonGadget(#frmAddEdit_cmdOK, 335, 75, 65, 25, "OK") 
          ButtonGadget(#frmAddEdit_cmdCancel, 405, 75, 65, 25, "Cancel", #PB_Button_Default)
          
          SetWindowColor(#frmAddEdit, $A2BADA)
          SetActiveGadget(#frmAddEdit_txtName) ; assure focus when opened

          ProcedureReturn  #True 
          
     EndIf 
     
EndProcedure 

Procedure Close_frmAddEdit() 
     DisableWindow(#frmMain, #False) ;now enable main window
     CloseWindow(#frmAddEdit) 
EndProcedure 

Procedure LoadStations() 
     
     Protected StationCounter.i 
     Protected StationName.s 
     Protected StationUrl.s 
     Protected Result.s
     
     If OpenPreferences("EasyPalette.ini") 
          
          Repeat 
               
               StationCounter + 1 
               
               StationName = ReadPreferenceString("Name" + Str(StationCounter), "") 
               StationUrl  = ReadPreferenceString("HexString"  + Str(StationCounter), "") 
               
               If StationName = "" And StationUrl = "" : Break : EndIf 
               
               AddElement(Stations()) 
               
               Stations()\Name = StationName 
               Stations()\Url = StationUrl 
               
          ForEver 
          
          ClosePreferences() 
          
     Else 
          
          MessageRequester("EasyPalette List", "Couldn't read list") 
          
     EndIf 
     
EndProcedure 

Procedure SaveStations() 
     
     Protected StationCounter.i 
     
     If CreatePreferences("EasyPalette.ini") 
          
          ForEach Stations() 
               
               StationCounter + 1 
               
               WritePreferenceString("Name" + Str(StationCounter),  Stations()\Name) 
               WritePreferenceString("HexString"  + Str(StationCounter),  Stations()\Url) 
               
          Next 
          
          ClosePreferences() 
          
     Else 
          
          MessageRequester("EasyPalette List", "Couldn't write list") 
          
     EndIf 
     
EndProcedure

Procedure frmMain_CheckButtons() 
     
     Protected Flag.i 
     
     If GetGadgetState(#frmMain_ligStations) > -1 : Flag = #False :  Else : Flag = #True : EndIf 
     
     DisableGadget(#frmMain_cmdEdit, Flag) 
     DisableGadget(#frmMain_cmdDelete, Flag) 
     
EndProcedure

Procedure frmAddEdit_CheckButtons() 
     
     Protected Flag.i 

     If GetGadgetText(#frmAddEdit_txtName) = "" And GetGadgetText(#frmAddEdit_txtUrl) = "" 
          Flag=#True 
     Else 
          Flag=#False 
     EndIf 
     
     DisableGadget(#frmAddEdit_cmdOK, Flag) 
     
EndProcedure 

Procedure EditStation() 
     Mode = #EditStation 
     Open_frmAddEdit() 
     SetWindowTitle(#frmAddEdit, GetWindowTitle(#frmAddEdit) + " - Edit Palette") 
     SetGadgetText(#frmAddEdit_txtName, GetGadgetItemText(#frmMain_ligStations, GetGadgetState(#frmMain_ligStations), 0)) 
     SetGadgetText(#frmAddEdit_txtUrl,  GetGadgetItemText(#frmMain_ligStations, GetGadgetState(#frmMain_ligStations), 1))
     frmAddEdit_CheckButtons() 
EndProcedure

Procedure AddStation() 
     Mode = #AddStation 
     Open_frmAddEdit() 
     SetWindowTitle(#frmAddEdit, GetWindowTitle(#frmAddEdit) + " - Add Palette") 
     frmAddEdit_CheckButtons() 
EndProcedure 

Procedure DeleteStation() 
     
     Protected SelectedItem.i 
     
     If MessageRequester("EasyPalette List", "Are you sure?", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes 
          SelectElement(Stations(), GetGadgetState(#frmMain_ligStations)) 
          DeleteElement(Stations()) 
          SelectedItem = GetGadgetState(#frmMain_ligStations) 
          RemoveGadgetItem(#frmMain_ligStations, SelectedItem) 
          If SelectedItem > CountGadgetItems(#frmMain_ligStations) - 1 
               SelectedItem = CountGadgetItems(#frmMain_ligStations) - 1 
          EndIf 
          If SelectedItem > -1 
               SetGadgetState(#frmMain_ligStations, SelectedItem) 
          EndIf 
     EndIf 
     
     frmMain_CheckButtons() 
     
EndProcedure 

Procedure Main() 
     
     Protected WWE.i, Quit.i
     Protected destination$, temp$
     
     LoadStations() 
     
     If Open_frmMain() = #False : End : EndIf 
     
     ForEach Stations() 
          AddGadgetItem(#frmMain_ligStations, -1, Stations()\Name + Chr(10) + Stations()\Url) 
     Next 
     
     If CountGadgetItems(#frmMain_ligStations) > 0 
          SetGadgetState(#frmMain_ligStations, 0) 
     EndIf 
     
     frmMain_CheckButtons() 
     
     Repeat 
          
          WWE = WaitWindowEvent() 
          
          Select WWE 
                    
               Case #PB_Event_Gadget 
                    
                    Select EventGadget() 
                              
                         Case #frmMain_ligStations 
                              If EventType() = #PB_EventType_LeftDoubleClick 
                                   If GetGadgetState(#frmMain_ligStations) > -1 
                                        EditStation() 
                                   EndIf 
                              Else 
                                   frmMain_CheckButtons() 
                              EndIf 
                              
                         Case #frmMain_cmdAdd 
                              AddStation() 
                              
                         Case #frmMain_cmdEdit 
                              EditStation() 
                              
                         Case #frmMain_cmdDelete 
                              DeleteStation()
                              
                         Case #frmMain_cmdCopyINI
                              ; Name of Backup file.
                              destination$ = "EasyPaletteBUP.ini"
                              CopyFile(sFile, destination$)
                               
                         Case #frmAddEdit_cmdCopy
                              temp$ = GetGadgetText(#frmAddEdit_txtUrl)
                              SetClipboardText(temp$)
 
                         Case #frmMain_cmdExit 
                              Quit = #True 
                              
                         Case #frmAddEdit_txtName 
                              frmAddEdit_CheckButtons() 
                              
                         Case #frmAddEdit_txtUrl 
                              frmAddEdit_CheckButtons() 
                              
                         Case #frmAddEdit_cmdOK 
                              
                              Select Mode 
                                        
                                   Case #AddStation 
                                        AddElement(Stations()) 
                                        Stations()\Name = GetGadgetText(#frmAddEdit_txtName) 
                                        Stations()\Url  = GetGadgetText(#frmAddEdit_txtUrl) 
                                        AddGadgetItem(#frmMain_ligStations, -1, Stations()\Name + Chr(10) + Stations()\Url) 
                                        SetGadgetState(#frmMain_ligStations, CountGadgetItems(#frmMain_ligStations)-1) 
                                        frmMain_CheckButtons() 
                                        
                                   Case #EditStation 
                                        SelectElement(Stations(), GetGadgetState(#frmMain_ligStations)) 
                                        Stations()\Name = GetGadgetText(#frmAddEdit_txtName) 
                                        Stations()\Url  = GetGadgetText(#frmAddEdit_txtUrl) 
                                        SetGadgetItemText(#frmMain_ligStations, GetGadgetState(#frmMain_ligStations), Stations()\Name, 0) 
                                        SetGadgetItemText(#frmMain_ligStations, GetGadgetState(#frmMain_ligStations), Stations()\Url,  1) 
                                        
                              EndSelect 
                              
                              Close_frmAddEdit() 
                              
                         Case #frmAddEdit_cmdCancel 
                              Close_frmAddEdit() 
                         
                    EndSelect 
                    
               Case #PB_Event_CloseWindow 
                    
                    Select EventWindow() 
                              
                         Case #frmMain 
                              Quit = #True 
                             
                         Case #frmAddEdit 
                              Close_frmAddEdit() 
                              
                    EndSelect 
                    
                    
          EndSelect 
          
     Until Quit = #True 
     
     If MessageRequester("EasyPalette List", "To save changes press 'Yes'... otherwise 'No'", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes 
          SaveStations() 
     EndIf 

     
EndProcedure 

;==================================================================
;------- Test Area -------
;==================================================================

CompilerIf #PB_Compiler_IsMainFile

     ; Your code here
     main()
CompilerEndIf


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 361
; FirstLine = 67
; Folding = Fg
; EnableXP
; Executable = EasyColorDB.exe