﻿; -----------------------------------------------------------------------------
;           Name: EasyPalette
;    Description: Look at pleasing color combinations for building forms, etc. 
;         Author: blueb
;           Date: 2017-05-31
;        Version:
;     PB-Version: 5.60(x86)
;             OS: Win 10 Pro
;         Credit: 
;          Forum:
;     Created by: SweetyVD and ChrisR
; -----------------------------------------------------------------------------

EnableExplicit

XIncludeFile "HexHelpers.pbi"

Global RecCount.i, PaletteCounter.i

; Structure to hold INI file colors
Structure IniInfo
     Name.s 
     HexString.s 
EndStructure 

Global NewList Rec.IniInfo() 

PaletteCounter = 1

Enumeration Window
	#Window_0
EndEnumeration

Enumeration Gadgets
	#Container_1
	#Container_2
	#Container_3
	#Container_4
	#Container_5
	#Container_6
	#Image_1
	#Text_1
	#Text_2
	#Text_3
	#Text_4
	#Text_5
	#Text_6
	#Text_7
	#Text_7b
	#Text_8
	#Text_9
	#Option_1
	#Button_3
	#Button_4
	#Button_5
	#Button_6
	#Option_2
	#Button_1
	#Button_2
	#Option_3
EndEnumeration

Enumeration FormImage
	#Img_Window_1
EndEnumeration
 
UsePNGImageDecoder()

LoadImage(#Img_Window_1, "Palette Logo.png")

Define iEvent.i,TextResult.s, Quit.i

; ------------------------------------------------
Declare myCallback(hWnd, uMsg, wParam, lParam)
Declare Open_Window_0(X = 0, Y = 0, Width = 650, Height = 450)
Declare FillContainers(PaletteCounter.i, Option.i)
Declare ImportColors()
Declare GetRecord(PaletteCounter)
; ------------------------------------------------

Procedure myCallback(hWnd, uMsg, wParam, lParam)
     ;used for Option Button background color
     Global Optioncolor = CreateSolidBrush_(RGB(218, 186, 162)) ; uses the same backgound as screen
 
     Select uMsg
          Case #WM_CTLCOLORSTATIC
                If lparam = GadgetID(#Option_1)
                    ProcedureReturn Optioncolor
               EndIf
               If lparam = GadgetID(#Option_2)
                    ProcedureReturn Optioncolor
               EndIf
               If lparam = GadgetID(#Option_3)
                    ProcedureReturn Optioncolor
               EndIf

     EndSelect
     
     ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

Procedure Open_Window_0(X = 0, Y = 0, Width = 650, Height = 450)
  Protected GrabColor.i = $CCF9FF
     
	If OpenWindow(#Window_0, X, Y, Width, Height, "Easy Palette 1.0", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
		SetWindowColor(#Window_0, RGB(218, 186, 162))
		ContainerGadget(#Container_1, 0, 0, 650, 60)
			SetGadgetColor(#Container_1, #PB_Gadget_BackColor, RGB(0, 103, 153))
			CloseGadgetList()
		ContainerGadget(#Container_2, 30, 125, 110, 180, #PB_Container_Flat)
			CloseGadgetList()
		ContainerGadget(#Container_3, 150, 125, 110, 180, #PB_Container_Flat)
			CloseGadgetList()
		ContainerGadget(#Container_4, 270, 125, 110, 180, #PB_Container_Flat)
			CloseGadgetList()
		ContainerGadget(#Container_5, 390, 125, 110, 180, #PB_Container_Flat)
			CloseGadgetList()
		ContainerGadget(#Container_6, 510, 125, 110, 180, #PB_Container_Flat)
			CloseGadgetList()
			ImageGadget(#Image_1, 10, 5, 50, 40, ImageID(#Img_Window_1))
			
	     If LoadFont(1, "Arial Rounded MT Bold", 32, #PB_Font_Italic)
		     TextGadget(#Text_7, 90, 5, 510, 50, "Easy Palette")
               SetGadgetFont(#Text_7, FontID(1))
          	SetGadgetColor(#Text_7, #PB_Gadget_FrontColor, RGB(255, 255, 255))
			SetGadgetColor(#Text_7, #PB_Gadget_BackColor, RGB(0, 103, 153))
		EndIf
		
		If LoadFont(2, "Arial Rounded MT Bold", 24)
		     TextGadget(#Text_6, 130, 75, 390, 50, "myChosen Palette", #PB_Text_Center)
		     SetGadgetFont(#Text_6, FontID(2))
		     SetGadgetColor(#Text_6, #PB_Gadget_FrontColor, RGB(255, 255, 255))
               SetGadgetColor(#Text_6, #PB_Gadget_BackColor, RGB(218, 186, 162))
          EndIf
          
 		If LoadFont(3,"Cataneo BT", 14)
               ;add PB
               TextGadget(#Text_7b, 360, 27, 130, 25, "for form designs")
               SetGadgetFont(#Text_7b, FontID(3))
          	SetGadgetColor(#Text_7b, #PB_Gadget_FrontColor, RGB(255, 255, 255))
			SetGadgetColor(#Text_7b, #PB_Gadget_BackColor, RGB(0, 103, 153))
		EndIf
		
		StringGadget(#Text_1, 30, 315, 110, 18, "RGB(123,123,123)", #PB_String_ReadOnly | #PB_Text_Center)
			SetGadgetColor(#Text_1, #PB_Gadget_BackColor, GrabColor)
		StringGadget(#Text_2, 150, 315, 110, 18, "RGB(123,123,123)", #PB_String_ReadOnly | #PB_Text_Center)
			SetGadgetColor(#Text_2, #PB_Gadget_BackColor, GrabColor)
		StringGadget(#Text_3, 270, 315, 110, 18, "RGB(123,123,123)", #PB_String_ReadOnly | #PB_Text_Center)
			SetGadgetColor(#Text_3, #PB_Gadget_BackColor, GrabColor)
		StringGadget(#Text_4, 390, 315, 110, 18, "RGB(123,123,123)", #PB_String_ReadOnly | #PB_Text_Center)
			SetGadgetColor(#Text_4, #PB_Gadget_BackColor, GrabColor)
		StringGadget(#Text_5, 510, 315, 110, 18, "RGB(123,123,123)", #PB_String_ReadOnly | #PB_Text_Center)
		SetGadgetColor(#Text_5, #PB_Gadget_BackColor, GrabColor)
		
		; helpful
		TextGadget(#Text_8, 147, 340, 80, 18, "Hint:")
		SetGadgetColor(#Text_8, #PB_Gadget_FrontColor, RGB(255, 0, 0))
		SetGadgetColor(#Text_8, #PB_Gadget_BackColor, RGB(218, 186, 162))
		
		TextGadget(#Text_9, 160, 355, 300, 35, "Click on a text-box and save the color to the clipboard.")
		SetGadgetColor(#Text_9, #PB_Gadget_BackColor, RGB(218, 186, 162))
		;
		ButtonGadget(#Button_3, 500, 360, 30, 30, "|<")
		ButtonGadget(#Button_4, 530, 360, 30, 30, "<")
		ButtonGadget(#Button_5, 560, 360, 30, 30, ">")
		ButtonGadget(#Button_6, 590, 360, 30, 30, ">|")
		ButtonGadget(#Button_1, 365, 400, 130, 35, "Database")
		ButtonGadget(#Button_2, 500, 400, 120, 35, "Quit")

		OptionGadget(#Option_1, 30, 360, 110, 20, "Display RGB()")
		SetGadgetState(#Option_1, 1)   ; set active
		OptionGadget(#Option_2, 30, 390, 110, 20, "Display PB Hex")
		OptionGadget(#Option_3, 30, 420, 110, 20, "Display HTML Hex")
	
	EndIf
	SetWindowCallback(@myCallback()) ; For OptionGadget() background color.
	ImportColors()
	FillContainers(1,1) ; initial screen fill

EndProcedure
	
Procedure FillContainers(PaletteCounter.i, Option.i) ; which type RGB, etc
  Protected Hstring.s, k.i, ans.s                        
     
  Dim ParseHex.s(5)
  Dim ContainerColor.s(5)

  GetRecord(PaletteCounter)
 
  SetGadgetText(#Text_6, Rec()\Name) ; Get this palette's name.
                                       ;
    
     ;Parse the HEX string for display...
     Hstring.s = Rec()\HexString ; Get this palette's color string from database
     For k = 1 To 5             ; if you have more than 5 colors in the record it parses it to 5 colors max.
          ParseHex(k) = StringField(Hstring, k, ",")
     Next k
     
     ; Set container colors
     SetGadgetColor(#Container_2, #PB_Gadget_BackColor, Hex2RGBvalue(ParseHex(1)))
     SetGadgetColor(#Container_3, #PB_Gadget_BackColor, Hex2RGBvalue(ParseHex(2))) 
     SetGadgetColor(#Container_4, #PB_Gadget_BackColor, Hex2RGBvalue(ParseHex(3)))
     SetGadgetColor(#Container_5, #PB_Gadget_BackColor, Hex2RGBvalue(ParseHex(4))) 
     SetGadgetColor(#Container_6, #PB_Gadget_BackColor, Hex2RGBvalue(ParseHex(5))) 
 
     If Option = 1 ; sets and returns RGB() values for later use.
          SetGadgetText(#Text_1, Hex2RGB(ParseHex(1))):ContainerColor(1) = GetGadgetText(#Text_1)
          SetGadgetText(#Text_2, Hex2RGB(ParseHex(2))):ContainerColor(2) = GetGadgetText(#Text_2)
          SetGadgetText(#Text_3, Hex2RGB(ParseHex(3))):ContainerColor(3) = GetGadgetText(#Text_3)
          SetGadgetText(#Text_4, Hex2RGB(ParseHex(4))):ContainerColor(4) = GetGadgetText(#Text_4)
          SetGadgetText(#Text_5, Hex2RGB(ParseHex(5))):ContainerColor(5) = GetGadgetText(#Text_5)
     EndIf
     If Option = 2 ; PureBasic Hex
          SetGadgetText(#Text_1, HTMLtoPBHex(ParseHex(1))):ContainerColor(1) = GetGadgetText(#Text_1)
          SetGadgetText(#Text_2, HTMLtoPBHex(ParseHex(2))):ContainerColor(2) = GetGadgetText(#Text_2)
          SetGadgetText(#Text_3, HTMLtoPBHex(ParseHex(3))):ContainerColor(3) = GetGadgetText(#Text_3)
          SetGadgetText(#Text_4, HTMLtoPBHex(ParseHex(4))):ContainerColor(4) = GetGadgetText(#Text_4)
          SetGadgetText(#Text_5, HTMLtoPBHex(ParseHex(5))):ContainerColor(5) = GetGadgetText(#Text_5)
     EndIf
     If Option = 3 ; HTML Hex
          SetGadgetText(#Text_1, ParseHex(1)):ContainerColor(1) =GetGadgetText(#Text_1)
          SetGadgetText(#Text_2, ParseHex(2)):ContainerColor(2) = GetGadgetText(#Text_2)
          SetGadgetText(#Text_3, ParseHex(3)):ContainerColor(3) = GetGadgetText(#Text_3)
          SetGadgetText(#Text_4, ParseHex(4)):ContainerColor(4) = GetGadgetText(#Text_4)
          SetGadgetText(#Text_5, ParseHex(5)):ContainerColor(5) = GetGadgetText(#Text_5)
     EndIf     
  
     
EndProcedure

Procedure ImportColors() 
  Protected IniName.s, IniHexString.s, Result.s
     
     If OpenPreferences("EasyPalette.ini") 
       RecCount = 1  
          Repeat 
               IniName = ReadPreferenceString("Name" + Str(RecCount), "") 
               IniHexString  = ReadPreferenceString("HexString"  + Str(RecCount), "") 
               
               If IniName = "" And IniHexString = "" : Break : EndIf 
               
               ; Add free Element
               AddElement(Rec()) 
               
               ; Insert values into our element
               Rec()\Name = IniName 
               Rec()\HexString = IniHexString 
               
              RecCount + 1 ; icrement counter
          ForEver 
        ClosePreferences() 
          
     Else 
          MessageRequester("EasyPalette List", "Couldn't read list") 
     EndIf 
     
EndProcedure

Procedure GetRecord(Count.i)
; to allow for element 0 and other errors
      If Count => RecCount 
          Count = RecCount - 1
     EndIf
     
      If Count < 0
          count = 0
     EndIf
     
     ;select the item in the list
     SelectElement(Rec(), Count - 1)
     
EndProcedure

Open_Window_0()
;
;-......... my Event loop
;
Repeat 
 	iEvent = WaitWindowEvent()
	Select iEvent

	     Case #PB_Event_Gadget
	          
		     Select EventGadget()
               
		          Case #Text_1
		               If EventType() = #PB_EventType_Focus
		                    TextResult.s = GetGadgetText(#Text_1)
		                    SetClipboardText(TextResult)
     		          EndIf
     		          ; -------------
     		          
		          Case #Text_2
		               If EventType() = #PB_EventType_Focus
		                    TextResult.s = GetGadgetText(#Text_2)
		                    SetClipboardText(TextResult)
     		          EndIf
     		          ; -------------
                    Case #Text_3
		               If EventType() = #PB_EventType_Focus
		                    TextResult.s = GetGadgetText(#Text_3)
		                    SetClipboardText(TextResult)
     		          EndIf
     		          ; -------------
	               
		          Case #Text_4
		               If EventType() = #PB_EventType_Focus
		                    TextResult.s = GetGadgetText(#Text_4)
		                    SetClipboardText(TextResult)
     		          EndIf
     		          ; -------------
		               
		          Case #Text_5
		               If EventType() = #PB_EventType_Focus
		                    TextResult.s = GetGadgetText(#Text_5)
		                    SetClipboardText(TextResult)
     		          EndIf
     		          ; -------------

                    Case #Option_1
                         FillContainers(PaletteCounter, 1)
		          Case #Option_2
		               FillContainers(PaletteCounter, 2)
		          Case #Option_3
		               FillContainers(PaletteCounter, 3)
		               ; -------------
		               
		          Case #Button_3 ; '|<' button
		               PaletteCounter = 1
		               GetRecord(PaletteCounter)
		               FillContainers(PaletteCounter.i, 1)
		               SetGadgetState(#Option_1, 1)   ; set option as the active one
		               
		          Case #Button_4 ; '<' button
		               If PaletteCounter = 1
		                    GetRecord(1)
		                    FillContainers(PaletteCounter.i, 1)
		                    SetGadgetState(#Option_1, 1) 
		              Else 
		                   PaletteCounter = PaletteCounter - 1
		                   GetRecord(PaletteCounter)
		                   FillContainers(PaletteCounter.i, 1)
		                   SetGadgetState(#Option_1, 1) 
		              EndIf
		          
		          Case #Button_5 ; '>' button
		              If PaletteCounter = RecCount
		                    GetRecord(PaletteCounter)
		                    FillContainers(PaletteCounter, 1)
		                    SetGadgetState(#Option_1, 1)   ; set option as the active one
		              Else 
		                   PaletteCounter = PaletteCounter + 1
		                   GetRecord(PaletteCounter)
		                   FillContainers(PaletteCounter.i, 1)
		                   SetGadgetState(#Option_1, 1)   
		               EndIf

		          Case #Button_6 ; '>|' button
		               PaletteCounter = RecCount
		               GetRecord(PaletteCounter)
		               FillContainers(PaletteCounter, 1)
		               SetGadgetState(#Option_1, 1)   ; set option as the active one
		               
		          Case #Button_1 ; 'Database' button
		               RunProgram("EasyColorDB.exe") ; for source code open 'EasyColorDB.pb'
		              
				Case #Button_2 ; 'Quit' button
				     ;End 
				     Quit = #True
			EndSelect

		Case #PB_Event_CloseWindow
		     ; Erase items in memory on exit.
		    DeleteObject_(OptionColor)
		End
	EndSelect
Until Quit = #True


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 372
; FirstLine = 148
; Folding = g
; EnableXP
; UseIcon = PaletteLogo.ico
; Executable = EasyPalette.exe