﻿;==================================================================
;
; Author:    blueb    
; Date:       May 27, 2017
; Explain:
;           
; Typical Usage: Hex Color helpers          
;==================================================================
Procedure.s RGBvalue2_PBHex(Value.q) ; an HTML_Hex color is #FAEBD7 this returns $D7EBFA
 Protected Result$
     Result$ = Hex(Value.q, #PB_Long)
     ProcedureReturn "$" + Result$ 
EndProcedure


Procedure.i RandomRGBvalue(minlevel.w,maxlevel.w)
  Protected r, g, b
  r = Random(maxlevel-minlevel)+minlevel
  g = Random(maxlevel-minlevel)+minlevel
  b = Random(maxlevel-minlevel)+minlevel
  
  ProcedureReturn RGB(r,g,b)
  
EndProcedure

Procedure.i Hex2Dec(hex.s)
  Protected r, d, asc
  For r=1 To Len(hex)
      d<<4
      asc=Asc(Mid(hex,r,1))
      If asc>60
          d+asc-55
      Else
          d+asc-48
      EndIf
  Next
  ProcedureReturn d
  
EndProcedure

Procedure.i Hex2RGBvalue(hex.s)
     ; returns the value of RGB()
     ; e.g. RGB(250,235,215) yields: 14150650
     Protected r.s, g.s, b.s, sHex.s
     Protected third
 sHex = UCase(RemoveString(hex,"#"))
  
  third = Len(shex)/3
  r.s = Left(shex,third)
  g.s = Mid(shex,1+third,third)
  b.s = Right(shex,third)
  
  If third=1
      r+r
      g+g
      b+b
  EndIf
  
  ProcedureReturn RGB(Hex2Dec(r),Hex2Dec(g),Hex2Dec(b))
  
EndProcedure


Procedure.s RGBvalue2Hex(rgb.i,omithash.b=#False,minimise.b=#True)
Protected hex.s
  hex.s = ""
  hex + RSet(Hex(Red(rgb)), 2, "0")
  hex + RSet(Hex(Green(rgb)), 2, "0")
  hex + RSet(Hex(Blue(rgb)), 2, "0")
  
  If minimise
      If Left(hex,1)=Mid(hex,2,1) And Mid(hex,3,1)=Mid(hex,4,1) And Mid(hex,5,1)=Mid(hex,6,1)
          hex = Left(hex,1) + Mid(hex,4,1) + Mid(hex,6,1)
      EndIf
  EndIf
  
  If Not omithash
      hex = "#"+hex
  EndIf
  
  ProcedureReturn UCase(hex)
  
EndProcedure

Procedure.s Hex2RGB(hex.s)
     Protected r.s, g.s, b.s, sHex.s
     
     sHex = UCase(RemoveString(hex,"#"))
     
     r.s = Left(shex,2)
     g.s = Mid(shex,1+2,2)
     b.s = Right(shex,2)
     
     r = Str(Hex2Dec(r))
     g = Str(Hex2Dec(g))
     b = Str(Hex2Dec(b))
     ;Pad to 3 decimals
     r = RSet(r, 3, "0")
     g = RSet(g, 3, "0")
     b = RSet(b, 3, "0")
     ProcedureReturn  "RGB(" + r + ", " + g + ", " + b + ")"
     
EndProcedure

Procedure.s HTMLtoPBHex(hex.s)
     Protected r.s, g.s, b.s, sHex.s
     
     sHex = UCase(RemoveString(hex,"#"))
     
     r.s = Left(shex,2)
     g.s = Mid(shex,1+2,2)
     b.s = Right(shex,2)
     
     ProcedureReturn  "$" + b + g + r     
EndProcedure

; start here 
;==================================================================
;------- Test Area -------
;==================================================================

; CompilerIf #PB_Compiler_IsMainFile = 1
; 
; ; Your code here
; 
; Hex.s = "#FAEBD7" ; will trim the # sign
; 
; Debug Hex2RGB(hex.s)
; Debug "-------------------------------"
; Debug Hex2RGBvalue(Hex.s)
; Debug "----------"
; ans.s = RGBvalue2Hex(14150650,0,0) ; HTML value = #FAEBD7
; Debug ans
; Debug "------------"
; Hex = "FAEBD7"
; Debug Hex2Dec(hex.s)
; Debug "------------"
; Debug RandomRGBvalue(180,255) ; 200, 255
; Debug "========="
; value.q = 14150650 ; $D7EBFA
; Debug RGBvalue2_PBHex(Value)
; Debug "PB Hex"
; Debug HTMLtoPBHex(hex.s)
; CompilerEndIf
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 113
; FirstLine = 82
; Folding = --
; EnableXP